//
// Copyright 2016, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.
//
// Warning:  not all files in this directory structure may be covered by the
// same copyright.  Some of them may be part of the GNU source distribution
// and you must obey the GPL copyright for any such files.

char const *brashVersionLog[]=
{
    "\r\n",
    "Brash Version Log and Copyright Information.\r\n\r\n",
    "Versions:\r\n",
    "\r\n",
    "01.02.13   Bug Fix:      All builtin commands should be cognizant of the shell current directory\r\n",
    "                         and not open files from the program current directory.  Oops.\r\n",
    "           Bug Fix:      popd sometimes failed.\r\n",
    "01.02.12   Enhancement:  .ls now has the --sep=char option to specify a field sepator char.\r\n",
    "                         see .cut -h for ways of parsing delimited fields.\r\n",
    "           Enhancement:  .date now has the -p option.\r\n",
    "           Enhancement:  .ls now supports the --seconds option which prints the time as a utc integer\r\n",
    "                         when -l is used.\r\n",
    "01.02.11   Bug Fix:      Function names can now accept colon(:), underscore(_), and dot(.)\r\n",
    "01.02.10   Bug Fix:      Fixed function return values when the function ran in a subshell.\r\n",
    "01.02.09a- Enhancement:  Added text to the builtins command output to discuss arrays.\r\n",
    "01.02.09 - Enh/bug fix?  The =~ operator now handles standard escape sequences in the pattern (rhs).\r\n",
    "01.02.08 - Bug Fix/Enh:  The read command's -a option now works more like GNU bash.\r\n",
    "                         it now reads 1 line and splits the results into elements of\r\n",
    "                         an array variable.  The -F option now puts line the lines\r\n",
    "                         from a file into separate array elements, one per line.\r\n",
    "01.02.07d- Enhancement:  Add .copypaste and .tail.  control - C now interrupts .ls -R \r\n",
    "                         and .uniq command help message cleanup.\r\n",  
    "01.02.05 - Enhancement:  Add .printf command\r\n",
    "01.02.04 - Enhancement:  Add some new command line options to builtin commands:\r\n",
    "                            .ls gets --DOS for dos short path\r\n",
    "                            .regex gets -o for only printing the first matching pattern on a line\r\n",
    "01.02.03 - Bug fixed:   pipes inside pipes was going crazy sometimes.\r\n",
    "         - bug fixed:   bad command line parameters to .head crashed brash.\r\n",
    "01.02.02a- Enhancement: Adding .uniq.\r\n",
    "01.02.01 - Enhancement: Adding support for string arrays and maps.\r\n",
    "         - Enhancement:     Adding -1 to .regex to enable cross line substitutions.\r\n",
    "         - Bug fixed:   Arithmetic in for loop conditions is now string-expanded, so\r\n",
    "                            string expressions will work correctly.\r\n",
    "01.01.40 - Bug Fixed:   Bug in .linreg when last line did not end in newline\r\n",
    "01.01.39 - Bug Fixed:   Segment violation when executiong cmd /c <nothing>\r\n",
    "01.01.38 - Enhancement: Adding -n and -z [ operators ] and modified builtins logging.\r\n",
    "01.01.37 - Enhancement: Added additional [ operators ] and modified builtins to explain\r\n",
    "01.01.36 - Bug fixed: calling a function was corrupting $@ of the current scope\r\n",
    "01.01.35 - Bug fixed: getopt infinite loop bug if user specified multiple options in one -group\r\n",
    "01.01.34a- Port:      Port to Visual Studio 2015, no functionality changes\r\n",
    "01.01.33 - Bug fixed: $_ not working if last command was a script function\r\n",
    "\r\n",
    "Copyright Holders:\r\n",
    "\r\n",
    "   Copyright Lowell Boggs, Jr.  2016 -- for brash.  See details below.\r\n",
    "\r\n",
    "   Copyight GNU General Public License, 1993 -- for regex.c and .h\r\n",
    "\r\n",
    "   Copyright GNU Library Public License, 1991 -- for fnmatch.c\r\n",
    "\r\n",
    "   Copyright David L. Nugent, 1996 -- for parse_date.c\r\n",
    "       *  http://www.gnu-darwin.org/sources/src/usr.sbin/pw/psdate.c\r\n",
    "\r\n",
    "   Copyright WikiBooks.org:  LCS Algorithm used in .diff\r\n",
    "       *  https://en.wikibooks.org/w/index.php?title=Algorithm_Implementation/Strings/Longest_common_subsequence\r\n",
    "\r\n",
    "   Copyright (c) 1980, 1987, 1991, 1993 -- for wc.c (word count algorithm)\r\n",
    "       *  The Regents of the University of California.  All rights reserved.\r\n",
    "\r\n",
    "Brash Copyright:\r\n",

    "    //\r\n",
    "    // Copyright 2002-2016, Lowell Boggs Jr.\r\n",
    "    //\r\n",
    "    // This file or directory, containing source code for a computer program,\r\n",
    "    // is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville\r\n",
    "    // TX (USA), 75067.  You may use, copy, modify, and distribute this\r\n",
    "    // source file without charge or obligation so long as you agree to\r\n",
    "    // the following:\r\n",
    "    //\r\n",
    "    //  1.  You must indemnify Lowell Boggs against any and all financial\r\n",
    "    //      obligations caused by its use, misuse, function, or malfunction.\r\n",
    "    //      Further, you acknowledge that there is no warranty of any kind,\r\n",
    "    //      whatsoever.\r\n",
    "    //\r\n",
    "    //  2.  You agree not to attempt to patent any portion of this original\r\n",
    "    //      work -- though you may attempt to patent your own extensions to\r\n",
    "    //      it if you so choose.\r\n",
    "    //\r\n",
    "    //  3.  You keep this copyright notice with the file and all copies\r\n",
    "    //      of the file and do not change it anyway except language translation.\r\n",
    "    //\r\n",
    "    // You are responsible for enforcing your own compliance with these\r\n",
    "    // conditions and may not use this source file if you cannot agree to the\r\n",
    "    // above terms and conditions.\r\n",
    "    //\r\n",
    "    // Warning:  not all files in this directory structure may be covered by the\r\n",
    "    // same copyright.  Some of them may be part of the GNU source distribution\r\n",
    "    // and you must obey the GPL copyright for any such files.\r\n",
    "\r\n",
    (char const *)(0) // must be last
};
