//
// Copyright 2014, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.
#include <cxxtls/excel.h>
#include <stdio.h>
#include <string.h>

#ifdef _MSC_VER
#define snprintf _snprintf
#endif

namespace cxxtls
{

int excel2decimal(char const *str)
    ///  Convert a C-style string into an integer.  The string must
    ///  formatted like an excel column name:  A, B, AB, DEF, etc.
    ///
    ///  @param str[in]  The text  the excel column name.
    ///  @return An integer representing the string or -1.  Note that an
    ///          empty string is considered an error.
{
        char const *end = str + strlen(str);

        unsigned int value = 0;

        if(str == end)
           return -1;

        while (str != end)
        {
                char c = *str++;

                if (c < 'A' || c > 'Z')
                        return -c;

                c -= 'A';

                c += 1;

                value *= 26;
                value += c;
        }

        return value;


}

std::string decimal2excel(int value)
{


    static char const *letters = "ZABCDEFGHIJKLMNOPQRSTUVWXY";

    if(!value)
       return "";

    char buffer[40];

    char *output = &buffer[ sizeof(buffer) - 1 ];

    *output = 0;  


    while(value)
    {

        int nextDigit = (value / 26);
        int curDigit = (value % 26);

        if (curDigit == 0) nextDigit--;

        *--output = letters[curDigit];

        value = nextDigit;

    }

    return output;
}     

}
